
{$APPTYPE GUI}{$MODE DELPHI}

program Demo71;

uses
  SysUtils,windows,math,gl,glu,GraphOGL;

//const
 
//type
  
var 
  i:integer;
  esagon:array[0..5]of TGLVector = 
    ((x:-5;y:2;z:0),(x:-2.5;y:2;z:-4.5),(x:2.5;y:2;z:-4.5),
	 (x:5;y:2;z:0),(x:2.5;y:2;z:4.5),(x:-2.5;y:2;z:4.5));

  quads:array[0..3,0..3]of TGLVector = 
    (((x:-5;y:2;z:-5),(x:5;y:2;z:-5),(x:2.5;y:2;z:-2.5),(x:-2.5;y:2;z:-2.5)),
	 ((x:5;y:2;z:5),(x:-5;y:2;z:5),(x:-2.5;y:2;z:2.5),(x:2.5;y:2;z:2.5)),
	 ((x:5;y:2;z:-5),(x:5;y:2;z:5),(x:2.5;y:2;z:2.5),(x:2.5;y:2;z:-2.5)),
	 ((x:-5;y:2;z:5),(x:-5;y:2;z:-5),(x:-2.5;y:2;z:-2.5),(x:-2.5;y:2;z:2.5)));	

  arrov:array[0..2,0..2]of TGLVector = 
    (((x:0;y:2;z:-2.5),(x:5;y:2;z:0),(x:0;y:2;z:2.5)),
	 ((x:0;y:2;z:-2.5),(x:0;y:2;z:0),(x:-5;y:2;z:-5)),
	 ((x:0;y:2;z:2.5),(x:-5;y:2;z:5),(x:0;y:2;z:0)));
	 
   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(1,1, 0,1, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 1,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('FWOOD12.bmp',0);
  
end;
begin 

  OpenGL_Texture();
  
  
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,0,-35);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(45,1,0,0); 
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, -10,10,0, 0.1); 

  TextureSelectID(0);  
  
  // esagono
  glPushMatrix;
  glTranslatef(-11,0,0);   
  ExtrusionFromPolygon(esagon,-1/6);
  glPopMatrix;

  // quadrilatero bucato  
  glPushMatrix;
  glTranslatef(0,0,0);  
  ExtrusionFromPolygon(quads[0],-1/6);
  ExtrusionFromPolygon(quads[1],-1/6);
  ExtrusionFromPolygon(quads[2],-1/6);
  ExtrusionFromPolygon(quads[3],-1/6);
  glPopMatrix;
  
  // freccia
  glPushMatrix;
  glTranslatef(11,0,0);   
  ExtrusionFromPolygon(arrov[0],-1/6);
  ExtrusionFromPolygon(arrov[1],-1/6);
  ExtrusionFromPolygon(arrov[2],-1/6);
  glPopMatrix;  
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Esempio di estrusione', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
